config/routes.rb
Rails.application.routes.draw do
  get 'dashboard/index', as: :dashboard
  get 'charts/pie_knowlege_areas/show', as: 'pie_knowlege_areas_charts'
  get 'charts/pie_functional_areas/show', as: 'pie_functional_areas_charts'
  get 'charts/pie_blox_profiles/show', as: 'pie_blox_profiles_charts'
  get 'charts/column_bloxes/show', as: 'column_bloxes_charts'
  root 'dashboard#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/blox.rb
class Blox < ApplicationRecord
  has_many :knowlege_areas
  has_many :functional_areas
  has_many :blox_profiles
  has_many :cycles
  has_many :shifts

  def self.categories
    [
      OpenStruct.new(name: 'Ciclo', category: 'cycle'),
      OpenStruct.new(name: 'Turno', category: 'shift')
    ]
  end

  def self.count_by_table_and_blox_title(join_table, group_by_attribute)
    joins(join_table).group(group_by_attribute).group('bloxes.title').count
  end
end

app/models/blox_profile.rb
class BloxProfile < ApplicationRecord
  belongs_to :blox
end

app/models/cycle.rb
class Cycle < ApplicationRecord
  belongs_to :blox
end

app/models/functional_area.rb
class FunctionalArea < ApplicationRecord
  belongs_to :blox
end

app/models/knowlege_area.rb
class KnowlegeArea < ApplicationRecord
  belongs_to :blox
end

app/models/shift.rb
class Shift < ApplicationRecord
  belongs_to :blox
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/charts/column_bloxes_controller.rb
class Charts::ColumnBloxesController < ApplicationController
  def show
    render json: Blox.count_by_table_and_blox_title(join_table.to_sym, group_by_attribute).chart_json
  end

  private

  def group_by_attribute
    "#{join_table}.name"
  end

  def join_table
    column_blox_params.fetch(:column_blox, 'cycle').pluralize
  end

  def column_blox_params
    params.permit(:column_blox)
  end
end

app/controllers/charts/pie_blox_profiles_controller.rb
class Charts::PieBloxProfilesController < ApplicationController
  def show
    render json: Blox.joins(:blox_profiles).group("blox_profiles.name").count
  end
end

app/controllers/charts/pie_functional_areas_controller.rb
class Charts::PieFunctionalAreasController < ApplicationController
  def show
    render json: Blox.joins(:functional_areas).group("functional_areas.name").count
  end
end

app/controllers/charts/pie_knowlege_areas_controller.rb
class Charts::PieKnowlegeAreasController < ApplicationController
  def show
    render json: Blox.joins(:knowlege_areas).group("knowlege_areas.name").count
  end
end

app/controllers/dashboard_controller.rb
class DashboardController < ApplicationController
  def index
    @blox_count = Blox.count
    @blox_categories = Blox.categories
    @selected_blox_category = selected_blox_category
  end

  private

  def selected_blox_category
    dashboard_params.fetch(:blox_by, 'cycle')
  end

  def dashboard_params
    params.permit(:blox_by)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/dashboard_helper.rb
module DashboardHelper
  def donnut_options(blox_total)
    {
      donut: true,
      messages: { empty: 'No data' },
      library: { cutoutPercentage: 70, elements: { center: { text: "#{blox_total}"}}} }
  end

  def column_options
    { stacked: true, messages: { empty: 'No data' } }
  end
end

app/views/dashboard/index.html.erb
<div class="container mx-auto px-4">
  <div class="block">
    <h1 class="font-extrabold text-2xl">Dashboard</h1>
    <p class="text-gray-600">Visão geral do progresso dos Blox na instituição</p>
  </div>

  <div class="flex flex-col md:flex-row py-10">
    <div class="block md:flex-1 md:w-1/3 py-4">
      <div class="text-center"> Blox por Área de Competência </div>
      <%= pie_chart pie_knowlege_areas_charts_path, donnut_options(@blox_count) %>
    </div>
    <div class="block md:flex-1 md:w-1/3 py-4">
      <div class="text-center"> Blox por Área Funcional </div>
      <%= pie_chart pie_functional_areas_charts_path, donnut_options(@blox_count) %>
    </div>
    <div class="block md:flex-1 md:w-1/3 py-4">
      <div class="text-center"> Blox por Perfil </div>
      <%= pie_chart pie_blox_profiles_charts_path, donnut_options(@blox_count) %>
    </div>
  </div>

  <div class="block py-4">
    <%= form_with(url: dashboard_path, method: "get") do %>
      <div class="block py-5 font-extrabold">
        <%= label_tag 'blox_by', 'quantidade de blox por:', class: 'uppercase font-bold' %>
        <%= select_tag 'blox_by', options_for_select(@blox_categories.collect{ |u| [u.name, u.category] }, @selected_blox_category),
                                                     class: 'bg-gray-200 border border-gray-200 text-gray-700 py-3 px-4 pr-8 rounded leading-tight focus:outline-none focus:bg-white focus:border-gray-500' %>
      </div>
    <% end %>

    <%= column_chart column_bloxes_charts_path(column_blox: @selected_blox_category), column_options %>
  </div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>BloxDashboard</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <%= stylesheet_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>